/***************************************************************************
 * LPRng - An Extended Print Spooler System
 *
 * event dispatch for IPP internet printing protocol subscriptions
 * copyright 2021 Vaclav Michalek
 * 
 * See LICENSE for conditions of use.
 ***************************************************************************/


#ifndef _EVENT_H_
#define _EVENT_H_


/* events */

#define		E_NONE		0x0
#define		E_CLOSE		0x2

#define		E_SUBS_CREATE	0x10
#define		E_SUBS_ATTRS	0x11
#define		E_SUBS_RENEW	0x12
#define		E_SUBS_CANCEL	0x13
#define		E_SUBS_GNTF	0x14
#define		E_SUBS_CNTF	0x15
#define		E_PRS_CHANGE	0x20
#define		E_JOB_CREATE	0x21
#define		E_JOB_CHANGE	0x22


/* PROTOTYPES */

int Event_send2(int fd, int evno, int p1, int p2);
int Event_dispatch (int srv_fd, struct line_list *clnt_fd);
int Remove_closed_pipes (struct line_list *clnt_fd);


int EddLf(char *str, int ssize);
int EddIntData(char *str, int ssize, int datum);
int EddHexData(char *str, int ssize, const char *data, int datalen);
int ExmDataHex(char **data, const char *str);

#endif
