/***************************************************************************
 * LPRng - An Extended Print Spooler System
 *
 * Copyright 1988-2003, Patrick Powell, San Diego, CA
 *     papowell@lprng.com
 * See LICENSE for conditions of use.
 ***************************************************************************/



#ifndef _SSL_FUNC_H_
#define _SSL_FUNC_H_ 1

#ifdef SSL_ENABLE

#include <openssl/ssl.h>

/* PROTOTYPES */

int SSL_Initialize_ctx(SSL_CTX **ctx_ret, char *errmsg, int errlen);
void Destroy_ctx(SSL_CTX *ctx);
int Open_SSL_connection( int sock, SSL_CTX *ctx, SSL **ssl_ret,
        struct line_list *info, char *errmsg, int errlen );
int Accept_SSL_connection( int sock, int timeout, SSL_CTX *ctx, SSL **ssl_ret,
        struct line_list *info, char *errmsg, int errlen );
int Write_SSL_connection( int timeout, SSL *ssl, char *buffer, int len,
        char *errmsg, int errlen );
int Gets_SSL_connection( int timeout, SSL *ssl, char *inbuffer, int len,
        char *errmsg, int errlen );
int Read_SSL_connection( int timeout, SSL *ssl, char *inbuffer, int *len,
        char *errmsg, int errlen );
int Close_SSL_connection( int sock, SSL *ssl );

#endif /* SSL_ENABLE */

#endif
